 <?php

// $Id: mm_s3_test.inc,v 1.1.2.1.2.2 2008/12/04 23:09:42 arthuregg Exp $

/**
 * This file provides some testing configuration for the s3 module
 * files is based on http://undesigned.org.za/2007/10/22/amazon-s3-php-class
 */

/* **************************************************** */
/* Possible configuration */
/* **************************************************** */


$test_bucket = variable_get('mm_s3_bucket', str_replace(" ", "_", $conf['site_name'])) .'_test';

$test_upload = drupal_get_path('module', 'mm_s3'). '/test.png';

// file name is the file name
$test_upload_name = basename($test_upload);

// path to the download file. drupal files should be writeable
$test_download = file_directory_path() . '/s3_download_'. $test_upload_name;


/* **************************************************** */

// get the s3 drivers
mm_s3_class_check();

// Check if our upload file exists
if (!file_exists($test_upload) || !is_file($test_upload))
  exit("\nERROR: No such file: $test_upload\n\n");

// Check for CURL
if (!extension_loaded('curl') && !@dl(PHP_SHLIB_SUFFIX == 'so' ? 'curl.so' : 'php_curl.dll'))
  exit("\nERROR: CURL extension not loaded\n\n");

// Pointless without your keys!
if (awsAccessKey == 'change-this' || awsSecretKey == 'change-this')
  exit("\nERROR: AWS access information required\n\nPlease edit the following lines in this file:\n\n".
  "define('awsAccessKey', 'change-me');\ndefine('awsSecretKey', 'change-me');\n\n");

// Instantiate the class
$s3 = new S3(awsAccessKey, awsSecretKey);

// List your buckets:
$output[] ="Listing all buckets <br />S3::listBuckets(): ". theme('item_list', $s3->listBuckets());

// Create a bucket with public read access
if ($s3->putBucket($test_bucket, S3::ACL_PUBLIC_READ)) {
  $output[] ="Created bucket $test_bucket".PHP_EOL;

  // Put our file (also with public read access)
  if ($s3->putObjectFile($test_upload, $test_bucket, baseName($test_upload), S3::ACL_PUBLIC_READ)) {
    $output[] ="S3::putObjectFile(): File copied to {$test_bucket}/".baseName($test_upload).PHP_EOL;

    // Get the contents of our bucket
    $contents = $s3->getBucket($test_bucket);
    $output[] ="S3::getBucket(): Files in bucket {$test_bucket}: ".  theme('item_list', $contents);

    // Get object info
    $info = $s3->getObjectInfo($test_bucket, baseName($test_upload));
    $output[] ="S3::getObjecInfo(): Info for $test_bucket/".baseName($test_upload).': '. theme('item_list', $info);

    // Delete our file
    if ($s3->deleteObject($test_bucket, baseName($test_upload))) {
      $output[] ="S3::deleteObject(): Deleted file\n";

      // Delete the bucket we created (a bucket has to be empty to be deleted)
      if ($s3->deleteBucket($test_bucket)) {
        $output[] ="S3::deleteBucket(): Deleted bucket {$test_bucket}\n";
      } else {
        $output[] ="S3::deleteBucket(): Failed to delete bucket (it probably isn't empty)\n";
      }

    } else {
      $output[] ="S3::deleteObject(): Failed to delete file\n";
    }
  } else {
    $output[] ="S3::putObjectFile(): Failed to copy file\n";
  }
}
else {
  $output[] ="S3::putBucket(): Unable to create bucket (it may already exist and/or be owned by someone else)\n";
}

